#!/bin/csh

#####
## Tries a simple mkdir, but if that fails, sets AFS permissions & tries again!
#####

set objdir=$1
set user=`whoami`

echo Running: ../fancy-mkdir.csh $objdir

if (-d $objdir) then
    echo "Hey, directory $objdir already exists\!"
    goto wrapup
endif    

mkdir $objdir && echo "Created object directory $objdir"

if (! -d /afs ) then
   echo "I don't think this machine has AFS, so I'm done here"
   goto noafs_wrapup
endif

### if mkdir failed, try giving user temporary write permission
if (($status > 0)) then
	fs sa . $user write
	mkdir $objdir && echo "Created object directory $objdir (the second time's the charm\!)"
	fs sa . $user none
endif

wrapup:

### finally, give everybody write permission in the new object dir
if (-d /afs ) then
   fs sa $objdir jab:moore.lab all system:campushost read -clear
endif


noafs_wrapup:
